/*
#
#
# By Amaury Carvalho
# Em 03/2007
#
#
*/

#ifndef _TEXT_
#define _TEXT_

    #include <iostream>
	#include <stdio.h>
	#include <stdlib.h>
	#include <string.h>
    
    using namespace std;
    
	// tipos usados pelo BD
	
	#define MAX_FILENAME_SIZE 256
	#define MAX_LINE_SIZE 1024
	#define MAX_LINES 65535
	
	class TTextFile {
          private :
              FILE* arq;
              
              char searchText[MAX_FILENAME_SIZE];
              int searchLine, searchTextLen;
              
              char line[MAX_LINE_SIZE];
              int count, positions[MAX_LINES], lengths[MAX_LINES];
              
          public :
		      char fileName[MAX_FILENAME_SIZE];
              bool opened;
		      
		      bool open(char *filename);
		      void close();
		         
	          char * lineText(int lineIndex);
	          char * lineText(int lineIndex, int start);
	          int lineLength(int lineIndex);
	          int lineCount();
	          
	          int searchStart(char *text);
	          int searchStart(char *text, int lineStart);
	          int searchNext();
	          
	          TTextFile();
	          ~TTextFile();
	          
	};

#endif
