/*
#
#
# By Amaury Carvalho
# Em 03/2007
#
#
*/

#ifndef _ELIZA_
#define _ELIZA_

        #include <iostream>
        #include <string>
        #include <ctime>
        #include "text.h"

        using namespace std;

        #define MAX_RESPONSES 30
        #define LEV_DIST_MIN 10
        
        class TEliza {
              private : 
                     TTextFile text;
                      
                     string sPreviousResponse, sPreviousInput;
                      
                     string find_match( string input );
                     string getResponseFromLine(int lineNo);
                     void UpperCase( string &str );
                     void cleanString( string &str );
                     bool isPunc(char c);
        
                     int levenshteinDistance(string &s, string &t);
                     int minimum(int v1, int v2, int v3);
                     
                     int lineIndex;
                      
              public :
                     string getResponse(string sInput);
                     
                     bool endTalk;
                     
                     TEliza();
                     ~TEliza();
        };

#endif
